unit chanpowercmds;

interface
uses
  buser , bstuff , accountUSINGbot , chanpowercmds_replies ,generalreplies;
{channel power (opall, kickall, chankill)}
procedure priv_kickall(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_opall(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_deopall(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_clearmode(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_clearbans(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_op(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_deop(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_invite(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);

implementation

{============================================================================ channel commands}
uses
  bchannel , bparse, bcmds , bconsts , btime , bconfig ;
procedure priv_kickall(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  ch:tchannel;
  uc:tuserchan;
  uc2:tuserchan;
  us:tuser;
  s:string;
  a:integer;
  notmatch:boolean;
begin
 with botobject do begin
  {if (parv[1] = '') or (parc < 2) then begin
    send(sendtalk+cmd+' <channel>');
    exit;
  end;}
  ch := findchan(parv[1]);
  if ch = nil then begin
    send(sendtalk+error_nosuchchannel(parv[1]));
    exit;
  end;

  s := '';
  for a := 2 to parc-1 do begin
    if s <> '' then s := s + ' ';
    s := s + parv[a];
  end;
  case hasmaster(sptr,ch) of
    access_false : begin
      send(sendtalk+reply_noaccess);
      exit;
    end;
    access_override : begin
      logaction(sptr,cmd+' '+ch.name+' '+s);

    end;
  end;

  if s <> '' then
  s := reply_masskick+' ('+s+')'
  else
  s := reply_masskick;
  repeat

    {find first matching user (not +k and not ircop)}
    uc := tuserchan(ch.user);
    notmatch := true;
    while (uc <> nil) and (notmatch) do begin
      us := uc.us;
      notmatch := flag_isset(us.modeflag,usermode_service){ or flag_isset(us.modeflag,usermode_oper)};

      uc2 := tuserchan(uc.next2);
      if not notmatch then sendparse(me.idstr+' '+TOK_KICK+' '+ch.name+' '+us.idstr+' :'+s);
      uc := uc2;

    end;
    if uc = nil then break;
  until false;
 end;
end;

procedure priv_opall(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  ch:tchannel;
  s,s2:string;
  uc:tuserchan;
begin
 with botobject do begin

  {if (parv[1] = '') or (parc < 2) then begin
    send(sendtalk+cmd+' <channel>');
    exit;
  end;}
  ch := findchan(parv[1]);
  if ch = nil then begin
    send(sendtalk+error_nosuchchannel(parv[1]));
    exit;
  end;
  case hasmaster(sptr,ch) of
    access_false : begin
      send(sendtalk+reply_noaccess);
      exit;
    end;
    access_override : begin
      logaction(sptr,cmd+' '+ch.name);

    end;
  end;

  s := '';
  s2 := '';
  uc := tuserchan(ch.user);
  while uc <> nil do begin
    if not flag_isset(uc.flags,userchanflag_op) then begin
      s := s + opchar;
      s2 := s2 + ' '+uc.us.idstr;
      if length(s) >= maxmodes then begin
        sendparse(botmodestring(mybot,ch)+' +'+s+s2);
        s := '';
        s2 := '';
      end;
    end;
    uc := tuserchan(uc.next2);
  end;
  if s <> '' then s:= botmodestring(mybot,ch)+' +'+s+s2;
  sendparse(s);
 end;
end;

procedure priv_deopall(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  ch:tchannel;
  s,s2:string;
  uc:tuserchan;
begin
 with botobject do begin

  {if (parv[1] = '') or (parc < 2) then begin
    send(sendtalk+cmd+' <channel>');
    exit;
  end;}
  ch := findchan(parv[1]);
  if ch = nil then begin
    send(sendtalk+error_nosuchchannel(parv[1]));
    exit;
  end;
  case hasmaster(sptr,ch) of
    access_false : begin
      send(sendtalk+reply_noaccess);
      exit;
    end;
    access_override : begin
      logaction(sptr,cmd+' '+ch.name);

    end;
  end;

  s := '';
  s2 := '';
  uc := tuserchan(ch.user);
  while uc <> nil do begin
    if not (flag_isset(uc.us.modeflag,usermode_service){ or flag_isset(uc.us.modeflag,usermode_oper)}) then begin
      if flag_isset(uc.flags,userchanflag_op) then begin
        s := s + opchar;
        s2 := s2 + ' '+uc.us.idstr;
        if length(s) >= maxmodes then begin
          sendparse(botmodestring(mybot,ch)+' -'+s+s2);
          s := '';
          s2 := '';
        end;
      end;
    end;
    uc := tuserchan(uc.next2);
  end;
  if s <> '' then sendparse(botmodestring(mybot,ch)+'  -'+s+s2);
 end;
end;

procedure priv_clearmode(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  ch:tchannel;
  s:string;
begin
 with botobject do begin

  {if (parv[1] = '') or (parc < 2) then begin
    send(sendtalk+cmd+' <channel>');
    exit;
  end;}

  ch := findchan(parv[1]);
  if ch = nil then begin
    send(sendtalk+error_nosuchchannel(parv[1]));
    exit;
  end;
  case hasmaster(sptr,ch) of
    access_false : begin
      send(sendtalk+reply_noaccess);
      exit;
    end;
    access_override : begin
      logaction(sptr,cmd+' '+ch.name);

    end;
  end;


  {$IFDEF no21011}
  s := 'mintspl';
  s2 := '';
  if ch.key <> '' then begin
    s := s + 'k';
    s2 := s2 + ' '+ch.key;
  end;
  sendparse(botmodestring(mybot,ch)+' -'+s+s2);
  {$ELSE}
  if (parc < 3) then s := '' else s := parv[2];
  sendparse(me.idstr+' '+TOK_CLEARMODE+' '+ch.name+' :'+s);
  {$ENDIF}
 end;
end;

procedure priv_clearbans(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  ch:tchannel;
begin
 with botobject do begin

  {if (parv[1] = '') or (parc < 2) then begin
    send(sendtalk+cmd+' <channel>');
    exit;
  end;}
  ch := findchan(parv[1]);
  if ch = nil then begin
    send(sendtalk+error_nosuchchannel(parv[1]));
    exit;
  end;
  case hasmaster(sptr,ch) of
    access_false : begin
      send(sendtalk+reply_noaccess);
      exit;
    end;
    access_override : begin
      logaction(sptr,cmd+' '+ch.name);

    end;
  end;



  {$IFDEF no21011}
  while ch.banlist <> nil do begin
    b := ch.banlist;
    s := '';
    s2 := '';
    while (b <> nil) and (length(s) < maxmodes) do begin
      s := s + 'b';
      s2 := s2 + ' '+b.mask;
      b := tban(b.next);
    end;
    if s <> '' then sendparse(botmodestring(mybot,ch)+'  -'+s+s2);
  end;
  {$ELSE}
  sendparse(me.idstr+' '+TOK_CLEARMODE+' '+ch.name+' :b');
  {$ENDIF}
 end;
end;

procedure priv_op(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  us           : tuser     ;
  ch           : tchannel  ;
  uc           : tuserchan ;
  s       , s2 : string    ;
  a            : integer   ;
  tempint      : integer   ;
  overrideused : boolean   ;
procedure flushmode;
begin
 with botobject do begin

  if s = '' then exit;
  sendparse(botmodestring(mybot,ch)+' +'+s+s2);
  s := '';
  s2 := '';
 end;
end;
procedure opone(us:tuser;nick:string);
begin
 with botobject do begin

  if us = nil then begin
    send(sendtalk+error_nosuchnick(nick));
    exit;
  end;
  if length(s) >= maxmodes then flushmode;
  s := s + opchar;
  s2 := s2 + ' '+us.idstr;
 end;
end;
begin
 with botobject do begin

  s := 'OP';
  for a := 1 to parc-1 do s := s + ' '+parv[a];

  if (parv[1] = '') or (parc < 2) then begin
    overrideused := false;
    us := sptr;
    uc := tuserchan(us.channel);
    while uc <> nil do begin
      tempint := hasop(sptr,uc.ch);
      if (not flag_isset(uc.flags,userchanflag_op))and (tempint <> access_false) then begin
        sendparse(botmodestring(mybot,uc.ch)+' +o '+us.idstr);
      end;
      if tempint = access_override then begin
        overrideused := true;
      end;
      uc := tuserchan(uc.next);
    end;
    if overrideused then begin
      logaction(sptr,s);

    end;
  end else begin
    ch := findchan(parv[1]);
    if ch = nil then begin
      send(sendtalk+error_nosuchchannel(parv[1]));
      exit;
    end;
    case hasop(sptr,ch) of
      access_false : begin
        send(sendtalk+reply_noaccess);
        exit;
      end;
      access_override : begin
        logaction(sptr,s);

      end;
    end;


    s := '';
    s2 := '';
    if (parc < 3) or (parv[2] = '') then begin
      opone(sptr,'')
    end else begin
      for a := 2 to parc-1 do opone(findnick(parv[a]),parv[a]);
    end;
    flushmode;
  end;
 end;
end;

procedure priv_deop(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  us:tuser;
  ch:tchannel;
  uc:tuserchan;
  s,s2:string;
  a:integer;
procedure flushmode;
begin
 with botobject do begin

  if s = '' then exit;
  sendparse(botmodestring(mybot,ch)+' -'+s+s2);
  s := '';
  s2 := '';
 end;
end;
procedure opone(us:tuser;nick:string);
begin
 with botobject do begin

  if us = nil then begin
    send(sendtalk+error_nosuchnick(nick));
    exit;
  end;
  if flag_isset(us.modeflag,usermode_service) then if not candeopk then begin
    send(sendtalk+nick+' '+reply_isaservice);
    exit;
  end;
  if length(s) >= maxmodes then flushmode;
  s := s + opchar;
  s2 := s2 + ' '+us.idstr;
 end;
end;
begin
 with botobject do begin

  s := cmd;//'DEOP';
  for a := 1 to parc-1 do s := s + ' '+parv[a];
  if (parv[1] = '') or (parc < 2) then begin
    us := sptr;
    uc := tuserchan(us.channel);
    while uc <> nil do begin
      if flag_isset(uc.flags,userchanflag_op) then begin
        sendparse(botmodestring(mybot,uc.ch)+' -o '+us.idstr);
      end;
      uc := tuserchan(uc.next);
    end;
  end else begin
    ch := findchan(parv[1]);
    if ch = nil then begin
      send(sendtalk+error_nosuchchannel(parv[1]));
      exit;
    end;
    {if not hasop(sptr,ch) then begin
      send(sendtalk+'no access');
      exit;
    end; }
    case hasop(sptr,ch) of
      access_false : begin
        send(sendtalk+reply_noaccess);
        exit;
      end;
      access_override : begin
        logaction(sptr,s);

      end;
    end;
    s := '';
    s2 := '';
    if (parc < 3) or (parv[2] = '') then begin
      opone(sptr,'')
    end else begin
      for a := 2 to parc-1 do opone(findnick(parv[a]),parv[a]);
    end;
    flushmode;
  end;
 end;
end;


procedure priv_invite(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  ch:tchannel;
  bool:boolean;
begin
 with botobject do begin

  if (parv[1] = '') or (parc < 2) then begin
    parv[1] := opt.operchannel;
    if parv[1] = '' then begin
      //send(sendtalk+'INVITE <channel>');
      send(sendtalk+replacespecial(syntax,mybot.name,me.name,cmd,#10+sendtalk));
      exit;
    end;
  end;
  ch := findchan(parv[1]);
  if ch = nil then begin
    send(sendtalk+error_nosuchchannel(parv[1]));
    exit
  end;



  case hasvoice(sptr,ch) of
    access_false : begin
      if hasop(sptr,ch)=access_false then begin
        send(sendtalk+'no access');
        exit;
      end;
    end;
    access_override : begin
      logaction(sptr,cmd+' '+ch.name);
    end;
  end;


  bool := getuserchan(mybot,ch) = nil;
  if bool then send(prefix+TOK_JOIN+' '+ch.name+' '+inttostr(irctime));
  send(prefix+TOK_INVITE+' '+sptr.name+' '+ch.name);
  if bool then send(prefix+TOK_PART+' '+ch.name);
 end;
end;

end.
