{
note : i do not mention package build mode in the readme
use the command line perameter dist to select it

this program can not be compiled with delphi, the build.exe is compiled with freepascal for windows
}

program build;
uses
  {$ifndef win32}
    {$ifdef ver1_0}
      linux,
    {$else}
      baseunix,unix,
    {$endif}
  {$endif}
  {$ifdef fpc}
  dos,
  {$endif}
  rpl2pasmain,
  sysutils;
{$I unixstuff.inc}
var
  fpcpath      : string;
  upxpath      : string;
  zippath      : string;
  pathtosearch : string;
  P            : integer;
  SearchRec    : TSearchRec;
  findresult   : integer;
  f            : text;
  f2           : text;
  botname      : string;
  answer       : string;
  tempstring   : string;
  counter      : integer;
  newstdin     : longint;
  oldstdin     : longint;
  distdir      : string;
  basename     : string;
const
  {$ifdef win32}
    pathseperator = ';';
    dirseperator  = '\';
    binaryext   = '.exe';
    defaultfpcpath = 'c:\pp\bin\win32\fpc.exe';
    defaultupxpath = 'c:\pp\bin\win32\upx.exe';
    defaultzippath = 'c:\pp\bin\win32\zip.exe';
  {$else}
    pathseperator = ':';
    dirseperator  = '/';
    binaryext   = '';
    defaultfpcpath = '/usr/local/bin/fpc';
    defaultupxpath = '/usr/local/bin/upx';
    defaultzippath = '/usr/local/bin/zip';
  {$endif}

procedure filecopy(source:string;dest:string);
var

  FromF, ToF: file;
  NumRead, NumWritten: Integer;
  Buf: array[1..2048] of Char;
begin
  AssignFile(FromF, source);
  Reset(FromF, 1);	{ Record size = 1 }
  AssignFile(ToF, dest);	{ Open output file }
  Rewrite(ToF, 1);	{ Record size = 1 }
  //Canvas.TextOut(10, 10, 'Copying ' + IntToStr(FileSize(FromF))  + ' bytes...');
  repeat
    BlockRead(FromF, Buf, SizeOf(Buf), NumRead);
    BlockWrite(ToF, Buf, NumRead, NumWritten);
  until (NumRead = 0) or (NumWritten <> NumRead);
  CloseFile(FromF);
  CloseFile(ToF);
  
  {$ifdef unix}
    chmod(dest,octal(755));
  {$endif}
end;

procedure basiccopytodistdir(name:string);
begin
  filecopy(name,distdir+name);
end;

procedure maskcopytodistdir(mask:string);
begin
  findresult := findfirst(mask,faanyfile,searchrec);
  while findresult=0 do begin
    basiccopytodistdir(searchrec.name);
    findresult := findnext(searchrec);

  end;
  findclose(searchrec);
end;

procedure expandfilemask(invalue : string);
begin
  findresult := FindFirst(extractfilepath(paramstr(0))+invalue,faAnyFile,searchrec);

  while findresult = 0 do begin
    writeln(f,searchrec.name);
    findresult := FindNext(SearchRec);
  end;
end;
procedure deletefiles(mask:string);
var
  f : tsearchrec;
  fr : integer;
begin
  fr := findfirst(mask,faanyfile,f);
  while fr=0 do begin
    deletefile(f.name);
    fr := findnext(f);
  end;
end;

begin
  deletefiles('core');
  deletefiles('*.o');
  deletefiles('*.ppu');
  deletefiles('*.ppw');
  deletefiles('*.dcu');
  deletefiles('*.o');
  deletefiles('*.ow');
  deletefiles('*.owr');
  deletefiles('bserv');
  deletefiles('bserv.exe');
  deletefiles('*.~pa');
  deletefiles('*.pas~');
  deletefiles('*.dpr~');
  deletefiles('*.~dp');
  deletefiles('*.log');
  deletefiles('*.map');
  //halt;     
  fpcpath := '';

  pathtosearch := getenv('PATH');
  repeat
    fpcpath := pathtosearch;
    if pos(pathseperator,fpcpath) <> 0 then begin
      p:=pos(pathseperator,fpcpath);
      setlength(fpcpath,p-1);

      pathtosearch := copy(pathtosearch ,p+1,32767);
    end else begin
      pathtosearch := '';
    end;
    fpcpath := fpcpath + dirseperator +'fpc'+binaryext;
    //writeln(fpcpath);
  until (pathtosearch = '') or fileexists(fpcpath);
  if not fileexists(fpcpath) then begin
    if fileexists(defaultfpcpath) then begin
      fpcpath := defaultfpcpath;
    end;
  end;
  if fileexists(fpcpath) then begin
    writeln('free pascal compiler found at '+fpcpath);
    writeln('use it y/n');
    readln(answer);

    if (length(answer) = 0) or (upcase(answer[1]) <> 'Y') then fpcpath := '';
  end else begin
    writeln('i can''t find your free pascal compiler binary');
  end;
  if not fileexists(fpcpath) then begin

    writeln('please type the full path and filename of your free pascal compiler binary');
    writeln('or delphi command line compiler binay');
    readln(fpcpath);
  end;

  findresult := FindFirst(extractfilepath(paramstr(0))+'*.pas', faAnyFile, SearchRec);
  assign(f,'bots.inc');
  rewrite(f);
  while findresult = 0 do begin
    botname := searchrec.name;
    setlength(botname,length(botname)-4);
    assign(f2,searchrec.name);
    reset(f2);
    readln(f2,tempstring);
    if tempstring = '{bot}' then begin
      repeat
        readln(f2,tempstring);
        if tempstring <> '' then writeln(copy(tempstring,2,length(tempstring)-2));
      until tempstring = '';
      writeln('use '+botname+'?y/n');
      readln(answer);

      if length(answer) > 0 then if upcase(answer[1]) = 'Y' then writeln(f,botname+',');

    end;

    close(f2);
    findresult := FindNext(SearchRec);
  end;
  findclose(searchrec);
  close(f);
  dorpl2pas(true);
  if uppercase(extractfilename(fpcpath))='DCC32.EXE' then begin
    exec(fpcpath,'bserv.dpr');
  end else begin;
    exec(fpcpath,'-Sd bserv.dpr'+{$ifdef win32}' -WG'{$else}'  -dipv6'{$endif});
  end;
  if uppercase(paramstr(1)) <> 'DIST' then halt;
  upxpath := '';
  {$ifdef win32}
    pathtosearch := getenv('PATH');
    repeat
      upxpath := pathtosearch;
      if pos(pathseperator,upxpath) <> 0 then begin
        p:=pos(pathseperator,upxpath);
        setlength(upxpath,p-1);

        pathtosearch := copy(pathtosearch ,p+1,32767);
      end else begin
        pathtosearch := '';
      end;
      upxpath := upxpath + dirseperator +'upx'+binaryext;
      //writeln(upxpath);
    until (pathtosearch = '') or fileexists(upxpath);
    if not fileexists(upxpath) then begin
      if fileexists(defaultupxpath) then begin
        upxpath := defaultupxpath;
      end;
    end;

    if fileexists(upxpath) then begin
      writeln('upx found at '+upxpath);
      writeln('use it y/n');
      readln(answer);

      if (length(answer) = 0) or (upcase(answer[1]) <> 'Y') then upxpath := '';
    end else begin
      writeln('i can''t find your upx binary');
    end;

    if not fileexists(upxpath) then begin

      writeln('please type the full path and filename of your upx binary');
      writeln('or press enter to skip upx stage');
      readln(upxpath);
    end;
    if upxpath <> '' then exec(upxpath,'-9 bserv'+binaryext);
  {$endif}
  (*pathtosearch := getenv('PATH');
  repeat
    zippath := pathtosearch;
    if pos(pathseperator,zippath) <> 0 then begin
      p:=pos(pathseperator,zippath);
      setlength(zippath,p-1);

      pathtosearch := copy(pathtosearch ,p+1,32767);
    end else begin
      pathtosearch := '';
    end;
    zippath := zippath + dirseperator +'zip'+binaryext;
    //writeln(zippath);
  until (pathtosearch = '') or fileexists(zippath);
  if not fileexists(zippath) then begin
    if fileexists(defaultzippath) then begin
      zippath := defaultzippath;
    end;
  end;
  if fileexists(zippath) then begin
    writeln('zip found at '+zippath);
    writeln('use it y/n');
    readln(answer);

    if (length(answer) = 0) or (upcase(answer[1]) <> 'Y') then zippath := '';
  end else begin
    writeln('i can''t find your zip binary');
  end;
  if not fileexists(zippath) then begin

    writeln('please type the full path and filename of your zip binary');
    writeln('or press enter to skip zip stage');
    readln(zippath);
  end;

  if zippath <> '' then begin
    writeln('enter name for zipfile');
    readln(answer);

    //unfortunately for us the linux version of info-zip will not parse
    //wildcards on the command line it seems to expect the shell to do it
    //writeln(zippath+' -9 '+answer+' bserv'+binaryext+' '+expandfilemask('*.cfg')+' '+expandfilemask('*.ini')+' '+expandfilemask('*.mrc')+' credits.txt readme.txt');
    {$ifdef win32}
      exec(zippath,'-9 '+answer+' bserv'+binaryext+' *.ini credits.txt readme.txt techchangelog.txt *mail.txt');

    {$else}
      // unfortunately very long command lines to exec get munged so
      // we feed the filenames to zip on stdin
      // i don't know how to use pipes so i just write the filenames
      // to a temporary file
      assign(f,'files.tmp');
      rewrite(f);
      writeln(f,+'bserv'+binaryext);
      expandfilemask('*.ini');
      writeln(f,'credits.txt');
      writeln(f,'readme.txt');
      writeln(f,'techchangelog.txt');
      writeln(f,'*mail.txt');
      closefile(f);

      // this is the standard unix way of redirecting stdin
      // stdin is file discriptor 0
      // dup copies a file discriptor into an empty file discriptor
      // dup2 copies a file discriptor into the file discriptor you
      // specify

      // first open a handle to the file
      newstdin := fdopen('files.tmp',Open_RdOnly);

      // save a copy of the orgininal standard input
      oldstdin := dup(0);

      // replace the stdin file discriptor with a copy of the one
      // we just opened
      dup2(newstdin,0);
      // close the file discriptor we copied into stdin

      fdclose(newstdin);
      // run the application
      exec(zippath,'-9 -@ '+answer);
      // restore stdin
      dup2(oldstdin,0);
      //and close the backup of stdin
      fdclose(oldstdin);
      deletefile('files.tmp');
    {$endif}

  end; *)
  distdir := '';
  while (distdir='') or fileexists(distdir) do begin
    if distdir <> '' then writeln('that dir alrady exists');
    writeln('enter name of subdir to put distribution files in');
    readln(distdir);
    if length(distdir)<>0 then if distdir[length(distdir)]<>dirseperator then distdir := distdir + dirseperator;

  end;
  mkdir(distdir);
  basiccopytodistdir('bserv'+binaryext);
  findresult := findfirst('*.distini',faanyfile,SearchRec);
  while findresult = 0 do begin
    basename := searchrec.name;
    setlength(basename,length(basename)-8);
    filecopy(searchrec.name,distdir+basename+'.ini');

    findresult := findnext(searchrec);
  end;
  findclose(searchrec);
  basiccopytodistdir('credits.txt');
  basiccopytodistdir('readme.txt');
  basiccopytodistdir('upgrade-notes.txt');
  basiccopytodistdir('changelog.txt');
  maskcopytodistdir('*mail.txt');
  {$ifdef win32}
    maskcopytodistdir('bewareserv*.bat');
  {$endif}

end.
